ImmutableMultimap
Date: 2016-05-24

com.google.common.collect

## Class ImmutableMultimap<K,V>

- java.lang.Object
- - com.google.common.collect.ImmutableMultimap<K,V>

- All Implemented Interfaces:
    Multimap<K,V>, java.io.Serializable
  Direct Known Subclasses:
    ImmutableListMultimap, ImmutableSetMultimap

      @GwtCompatible(emulated=true)
      public abstract class ImmutableMultimap<K,V>
      extends java.lang.Object
      implements java.io.Serializable

  A `Multimap` whose contents will never change, with many other important properties detailed at `ImmutableCollection`.

  Warning: avoid direct usage of `ImmutableMultimap` as a type (as with `Multimap` itself). Prefer subtypes such as `ImmutableSetMultimap` or `ImmutableListMultimap`, which have well-defined `equals(java.lang.Object)` semantics, thus avoiding a common source of bugs and confusion.

  Note: every `ImmutableMultimap` offers an `inverse()` view, so there is no need for a distinct `ImmutableBiMultimap` type.

  Key-grouped iteration. All view collections follow the same iteration order. In all current implementations, the iteration order always keeps multiple entries with the same key together. Any creation method that would customarily respect insertion order (such as `copyOf(Multimap)`) instead preserves key-grouped order by inserting entries for an existing key immediately after the last entry having that key.

  See the Guava User Guide article on immutable collections.

  Since:
    2.0
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ImmutableMultimap.Builder<K,V>` A builder for creating immutable multimap instances, especially `public static final` multimaps ("constant multimaps").

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ImmutableMap<K,java.util.Collection<V>>` | `asMap()` Returns an immutable map that associates each key with its corresponding values in the multimap.
    `static <K,V> ImmutableMultimap.Builder<K,V>` | `builder()` Returns a new builder.
    `void` | `clear()` Deprecated. Unsupported operation.
    `boolean` | `containsEntry(java.lang.Object key, java.lang.Object value)` Returns `true` if this multimap contains at least one key-value pair with the key `key` and the value `value`.
    `boolean` | `containsKey(java.lang.Object key)` Returns `true` if this multimap contains at least one key-value pair with the key `key`.
    `boolean` | `containsValue(java.lang.Object value)` Returns `true` if this multimap contains at least one key-value pair with the value `value`.
    `static <K,V> ImmutableMultimap<K,V>` | `copyOf(java.lang.Iterable<? extends java.util.Map.Entry<? extends K,? extends V>> entries)` Returns an immutable multimap containing the specified entries.
    `static <K,V> ImmutableMultimap<K,V>` | `copyOf(Multimap<? extends K,? extends V> multimap)` Returns an immutable multimap containing the same mappings as `multimap`, in the "key-grouped" iteration order described in the class documentation.
    `ImmutableCollection<java.util.Map.Entry<K,V>>` | `entries()` Returns an immutable collection of all key-value pairs in the multimap.
    `boolean` | `equals(java.lang.Object object)` Compares the specified object with this multimap for equality.
    `abstract ImmutableCollection<V>` | `get(K key)` Returns an immutable collection of the values for the given key.
    `int` | `hashCode()` Returns the hash code for this multimap.
    `abstract ImmutableMultimap<V,K>` | `inverse()` Returns an immutable multimap which is the inverse of this one.
    `boolean` | `isEmpty()` Returns `true` if this multimap contains no key-value pairs.
    `ImmutableMultiset<K>` | `keys()` Returns an immutable multiset containing all the keys in this multimap, in the same order and with the same frequencies as they appear in this multimap; to get only a single occurrence of each key, use `keySet()`.
    `ImmutableSet<K>` | `keySet()` Returns an immutable set of the distinct keys in this multimap, in the same order as they appear in this multimap.
    `static <K,V> ImmutableMultimap<K,V>` | `of()` Returns an empty multimap.
    `static <K,V> ImmutableMultimap<K,V>` | `of(K k1, V v1)` Returns an immutable multimap containing a single entry.
    `static <K,V> ImmutableMultimap<K,V>` | `of(K k1, V v1, K k2, V v2)` Returns an immutable multimap containing the given entries, in order.
    `static <K,V> ImmutableMultimap<K,V>` | `of(K k1, V v1, K k2, V v2, K k3, V v3)` Returns an immutable multimap containing the given entries, in the "key-grouped" insertion order described in the class documentation.
    `static <K,V> ImmutableMultimap<K,V>` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4)` Returns an immutable multimap containing the given entries, in the "key-grouped" insertion order described in the class documentation.
    `static <K,V> ImmutableMultimap<K,V>` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4, K k5, V v5)` Returns an immutable multimap containing the given entries, in the "key-grouped" insertion order described in the class documentation.
    `boolean` | `put(K key, V value)` Deprecated. Unsupported operation.
    `boolean` | `putAll(K key, java.lang.Iterable<? extends V> values)` Deprecated. Unsupported operation.
    `boolean` | `putAll(Multimap<? extends K,? extends V> multimap)` Deprecated. Unsupported operation.
    `boolean` | `remove(java.lang.Object key, java.lang.Object value)` Deprecated. Unsupported operation.
    `ImmutableCollection<V>` | `removeAll(java.lang.Object key)` Deprecated. Unsupported operation.
    `ImmutableCollection<V>` | `replaceValues(K key, java.lang.Iterable<? extends V> values)` Deprecated. Unsupported operation.
    `int` | `size()` Returns the number of key-value pairs in this multimap.
    `java.lang.String` | `toString()` Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.
    `ImmutableCollection<V>` | `values()` Returns an immutable collection of the values in this multimap.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### of

          public static <K,V> ImmutableMultimap<K,V> of()

      Returns an empty multimap.

    - #### of

          public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                        V v1)

      Returns an immutable multimap containing a single entry.

    - #### of

          public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                        V v1,
                                        K k2,
                                        V v2)

      Returns an immutable multimap containing the given entries, in order.

    - #### of

          public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                        V v1,
                                        K k2,
                                        V v2,
                                        K k3,
                                        V v3)

      Returns an immutable multimap containing the given entries, in the "key-grouped" insertion order described in the class documentation.

    - #### of

          public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                        V v1,
                                        K k2,
                                        V v2,
                                        K k3,
                                        V v3,
                                        K k4,
                                        V v4)

      Returns an immutable multimap containing the given entries, in the "key-grouped" insertion order described in the class documentation.

    - #### of

          public static <K,V> ImmutableMultimap<K,V> of(K k1,
                                        V v1,
                                        K k2,
                                        V v2,
                                        K k3,
                                        V v3,
                                        K k4,
                                        V v4,
                                        K k5,
                                        V v5)

      Returns an immutable multimap containing the given entries, in the "key-grouped" insertion order described in the class documentation.

    - #### builder

          public static <K,V> ImmutableMultimap.Builder<K,V> builder()

      Returns a new builder. The generated builder is equivalent to the builder created by the `ImmutableMultimap.Builder` constructor.

    - #### copyOf

          public static <K,V> ImmutableMultimap<K,V> copyOf(Multimap<? extends K,? extends V> multimap)

      Returns an immutable multimap containing the same mappings as `multimap`, in the "key-grouped" iteration order described in the class documentation.

      Despite the method name, this method attempts to avoid actually copying the data when it is safe to do so. The exact circumstances under which a copy will or will not be performed are undocumented and subject to change.

      Throws:
        `java.lang.NullPointerException` - if any key or value in `multimap` is null

    - #### copyOf

          @Beta
          public static <K,V> ImmutableMultimap<K,V> copyOf(java.lang.Iterable<? extends java.util.Map.Entry<? extends K,? extends V>> entries)

      Returns an immutable multimap containing the specified entries. The returned multimap iterates over keys in the order they were first encountered in the input, and the values for each key are iterated in the order they were encountered.
      Throws:
        `java.lang.NullPointerException` - if any key, value, or entry is null
      Since:
        19.0

    - #### removeAll

          @Deprecated
          public ImmutableCollection<V> removeAll(java.lang.Object key)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the multimap unmodified.
      Specified by:
        `removeAll` in interface `Multimap<K,V>`
      Returns:
        the values that were removed (possibly empty). The returned collection may be modifiable, but updating it will have no effect on the multimap.
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### replaceValues

          @Deprecated
          public ImmutableCollection<V> replaceValues(K key,
                                                        java.lang.Iterable<? extends V> values)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the multimap unmodified.
      Specified by:
        `replaceValues` in interface `Multimap<K,V>`
      Returns:
        the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### clear

          @Deprecated
          public void clear()

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the multimap unmodified.
      Specified by:
        `clear` in interface `Multimap<K,V>`
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### get

          public abstract ImmutableCollection<V> get(K key)

      Returns an immutable collection of the values for the given key. If no mappings in the multimap have the provided key, an empty immutable collection is returned. The values are in the same order as the parameters used to build this multimap.
      Specified by:
        `get` in interface `Multimap<K,V>`

    - #### inverse

          public abstract ImmutableMultimap<V,K> inverse()

      Returns an immutable multimap which is the inverse of this one. For every key-value mapping in the original, the result will have a mapping with key and value reversed.
      Since:
        11.0

    - #### put

          @Deprecated
          public boolean put(K key,
                               V value)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the multimap unmodified.
      Specified by:
        `put` in interface `Multimap<K,V>`
      Returns:
        `true` if the method increased the size of the multimap, or `false` if the multimap already contained the key-value pair and doesn't allow duplicates
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### putAll

          @Deprecated
          public boolean putAll(K key,
                                  java.lang.Iterable<? extends V> values)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the multimap unmodified.
      Specified by:
        `putAll` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### putAll

          @Deprecated
          public boolean putAll(Multimap<? extends K,? extends V> multimap)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the multimap unmodified.
      Specified by:
        `putAll` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### remove

          @Deprecated
          public boolean remove(java.lang.Object key,
                                  java.lang.Object value)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the multimap unmodified.
      Specified by:
        `remove` in interface `Multimap<K,V>`
      Returns:
        `true` if the multimap changed
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### containsKey

          public boolean containsKey(@Nullable
                            java.lang.Object key)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the key `key`.
      Specified by:
        `containsKey` in interface `Multimap<K,V>`

    - #### containsValue

          public boolean containsValue(@Nullable
                              java.lang.Object value)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the value `value`.
      Specified by:
        `containsValue` in interface `Multimap<K,V>`

    - #### size

          public int size()

      Description copied from interface: `Multimap`
      Returns the number of key-value pairs in this multimap.

      Note: this method does not return the number of distinct keys in the multimap, which is given by `keySet().size()` or `asMap().size()`. See the opening section of the `Multimap` class documentation for clarification.

      Specified by:
        `size` in interface `Multimap<K,V>`

    - #### keySet

          public ImmutableSet<K> keySet()

      Returns an immutable set of the distinct keys in this multimap, in the same order as they appear in this multimap.
      Specified by:
        `keySet` in interface `Multimap<K,V>`

    - #### asMap

          public ImmutableMap<K,java.util.Collection<V>> asMap()

      Returns an immutable map that associates each key with its corresponding values in the multimap. Keys and values appear in the same order as in this multimap.
      Specified by:
        `asMap` in interface `Multimap<K,V>`

    - #### entries

          public ImmutableCollection<java.util.Map.Entry<K,V>> entries()

      Returns an immutable collection of all key-value pairs in the multimap.
      Specified by:
        `entries` in interface `Multimap<K,V>`

    - #### keys

          public ImmutableMultiset<K> keys()

      Returns an immutable multiset containing all the keys in this multimap, in the same order and with the same frequencies as they appear in this multimap; to get only a single occurrence of each key, use `keySet()`.
      Specified by:
        `keys` in interface `Multimap<K,V>`

    - #### values

          public ImmutableCollection<V> values()

      Returns an immutable collection of the values in this multimap. Its iterator traverses the values for the first key, the values for the second key, and so on.
      Specified by:
        `values` in interface `Multimap<K,V>`

    - #### isEmpty

          public boolean isEmpty()

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains no key-value pairs. Equivalent to `size() == 0`, but can in some cases be more efficient.
      Specified by:
        `isEmpty` in interface `Multimap<K,V>`

    - #### containsEntry

          public boolean containsEntry(@Nullable
                              java.lang.Object key,
                              @Nullable
                              java.lang.Object value)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the key `key` and the value `value`.
      Specified by:
        `containsEntry` in interface `Multimap<K,V>`

    - #### equals

          public boolean equals(@Nullable
                       java.lang.Object object)

      Description copied from interface: `Multimap`
      Compares the specified object with this multimap for equality. Two multimaps are equal when their map views, as returned by `Multimap.asMap()`, are also equal.

      In general, two multimaps with identical key-value mappings may or may not be equal, depending on the implementation. For example, two `SetMultimap` instances with the same key-value mappings are equal, but equality of two `ListMultimap` instances depends on the ordering of the values for each key.

      A non-empty `SetMultimap` cannot be equal to a non-empty `ListMultimap`, since their `Multimap.asMap()` views contain unequal collections as values. However, any two empty multimaps are equal, because they both have empty `Multimap.asMap()` views.

      Specified by:
        `equals` in interface `Multimap<K,V>`
      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Returns the hash code for this multimap.

      The hash code of a multimap is defined as the hash code of the map view, as returned by `Multimap.asMap()`.

      Specified by:
        `hashCode` in interface `Multimap<K,V>`
      Overrides:
        `hashCode` in class `java.lang.Object`
      See Also:
        `Map.hashCode()`

    - #### toString

          public java.lang.String toString()

      Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation of the multimap